'-----------------------------------------------------------------------------------------
'name                     : ardu_alps_0_1.bas
'copyright                : free
'purpose                  : Alps motor Volume controller   for Amplifier and Preamplifier
'micro                    : Arduino Mini Pro
'version                  : 0.1
' this version with 3 input, RC5 remote control & motorized alps volume potentiometer ,
' backlight LED  control     ,
' mute is activ from remote an printed on LCD
'PB0 , PB1  = lines for motor control
'PD3     = IR Remote senzor tsop31236
'PC0 - PC5  = LCD lines connections
'PD2 = power button / switch
'PD1 = command for main power relay
'PD0 = sel + button / switch
'PD4 = sel - button / switch
'PD5 - PD7 =  command for relay  input selection 3 input
'PB2 = LCD backlight control line
'-----------------------------------------------------------------------------------------
$regfile = "m328pdef.dat"
$crystal = 8000000
$hwstack = 40
$swstack = 16
$framesize = 32
Ddrd = &B11100010                                           '
Portd = &B00011101                                          '
Config Lcdpin = Pin , Db4 = Portc.2 , Db5 = Portc.3 , Db6 = Portc.4 , Db7 = Portc.5 , E = Portc.1 , Rs = Portc.0
Config Portb = Output
Dim A As Bit                                                'first button
Dim B As Bit                                                'second button
Dim C As Bit                                                'third button
Dim W As Word
Dim Inp_sel As Byte
Dim Pwr As Bit
Dim Mut As Bit
Declare Sub Shiftlf                                         '
Declare Sub Shiftrt
Declare Sub Volup
Declare Sub Voldn
Declare Sub Poweron
Declare Sub Poweroff
Declare Sub Af_sel
Declare Sub Pwr_onof
Declare Sub Mute
Cursor Off
Config Lcd = 16 * 2                                         'other options are 16 * 4 and 20 * 4, 20 * 2 , 16 * 1a
'-----------IR const for RC5 to work-----------------
Const Samples_early = 8
Const Samples_late = 12
Const Samples_min = 3
Dim Sample As Byte
Dim Ir_lastsample As Byte
Dim Ir_bittimer As Byte
Dim Ir_data_tmp As Word
Dim Ir_bitcount As Byte
Dim Address_rc5 As Byte , Command_rc5 As Byte , Rc5_flag As Bit
Dim Set_ok As Byte , Setup_add As Bit
' TSOP1736 IR RC5 - 8Mhz !
Input_pin Alias Pind.3                                       'pin where is conected ir senzor
Config Timer0 = Timer , Prescale = 8                        'we use timer0 on ir routine
On Timer0 Timer_irq                                         'timer_irq is the interrupt routine for serving RC5 IR command
Const Timeconst = 78
Enable Timer0
'--------------------------------------------------------
Config Timer1 = Timer , Prescale = 1024                     'we use timer 1 for different manipulation of LCD and backlight
Stop Timer1
Set Portb.2                                                 'backlight on
Reset Portd.1                                               'main power relay off
Set Portb.0                                                 'both motor alps lines off = motor off
Set Portb.1                                                 'both motor alps lines off = motor off
Pwr = 0                                                     '0 =stand-by ; 1 = power on
Mut = 1                                                     ' 0 =mute , 1 = normal
Inp_sel = 1                                                 'default selected first input
Set Portd.5                                                 'disconect now input1
Set Portd.6                                                 'disconect now input2
Set Portd.7                                                 'disconect now input3
Cls                                                         'clear the LCD display
Lcd "Preamp controler"                                      'display this at the top line
Lowerline                                                   'select the lower line
Lcd "v=0.1(c)danzup"                                        'display this at the lower line
Wait 2                                                       'clear the LCD display
Cls
Enable Interrupts
 '--------------------------------------------------------------------------
If Pwr = 0 Then
Call Poweroff
End If
'--------------------------------------------------------------------------
Start Timer1
Do

If Pwr = 1 Then                                             'read at what number the timer1 is
   W = Timer1
 If W => 30000 Then                                         'we have reached the time for to switch backlight off
  Reset Portb.2                                             'backlight off
 End If
 If W => 800 Then                                           'we have reached the time for to switch motor off as we issued earlyer motor on
  Set Portb.0                                               'both motor alps lines off = motor off
  Set Portb.1                                               'both motor alps lines off = motor off
 End If
 If Mut = 1 Then
  If W => 4800 Then
   Lowerline
   Lcd "                 "
  End If
 End If
 If Rc5_flag = 1 Then
    Reset Rc5_flag
     If Address_rc5 <> 255 Then
      Command_rc5 = Command_rc5 And &B01111111
      Set Portb.2                                           'backlight on
      Select Case Command_rc5
      '---- this codes are for my remote , change code to your suit ! ----------------
      Case 33 : Call Shiftlf                                'remote command code for CH up
      Case 32 : Call Shiftrt                                'remote command code for CH down
      Case 16 : Call Volup                                  'remote command code for Vol +
      Case 17 : Call Voldn                                  'remote command code for Vol -
      Case 13 : Call Mute                                   'remote command code for Mute
      Case 12 : Call Pwr_onof                               'remote command code for On/Off
      End Select
      Command_rc5 = 255
      Address_rc5 = 255
      Reset Rc5_flag
     End If
 End If
 A = Pind.0                                                 'shift switch left pressed if Pind.0 = 0 then we shift input_source left
 B = Pind.4                                                 'shift switch right pressed if Pind.4 = 0 then we shift input_source right
 C = Pind.2                                                 'power switch pressed   if Pind.2 = 0
   If A = 0 Then                                            'now we read the push buttons for command
      Waitms 5
      Call Shiftlf                                          'button for left selection presed
   End If
   If B = 0 Then
      Waitms 5
      Call Shiftrt                                          'button for right selection presed
   End If
   If C = 0 Then                                            'power switch pressed
      Waitms 5
      Call Pwr_onof
   End If
End If

If Pwr = 0 Then
 C = Pind.2
 If Rc5_flag = 1 Then
    Reset Rc5_flag
     If Address_rc5 <> 255 Then
      Command_rc5 = Command_rc5 And &B01111111
      Set Portb.2                                           'backlight on
      Select Case Command_rc5
 '---- this codes are for my remote , change code to your suit ! ----------------
   Case 12 : Call Pwr_onof                                  'remote command code for On/Off
   End Select
   Command_rc5 = 255
   Address_rc5 = 255
   Reset Rc5_flag
   End If
 End If
 If C = 0 Then
      Waitms 5
      Call Pwr_onof
 End If
End If

Loop

End

'-----------Pwr_onof-----------------
Sub Pwr_onof:
Set Portb.2                                                 'backlight on
   Pwr = Not Pwr
   If Pwr = 1 Then
      Call Poweron
   Else
      Call Poweroff
   End If
End Sub
'------Poweron------------------------
Sub Poweron:
Set Portb.2                                                 'backlight on
Set Portd.1                                                 'main power relay on
Display On                                                  'turn display on
Cls
Lcd " Power On !    "
Cls
Call Af_sel
Home Lowerline
Lcd "               "
Waitms 500
W = 0
Timer1 = W
End Sub
'-------Poweroff----------------------
Sub Poweroff:
Cls
Lcd " Power  Off !  "
Waitms 500
Set Portd.5                                                 'disconect now input1
Set Portd.6                                                 'disconect now input2
Set Portd.7                                                 'disconect now input3
Reset Portb.2                                               'backlight off
Reset Portd.1                                               'main power relay off
Display Off                                                 'turn display off
Waitms 500
End Sub
'---------shift input Left----------
Sub Shiftlf:
Set Portb.2                                                 'backlight on
W = 0
Timer1 = W
If Inp_sel > 1 Then
Inp_sel = Inp_sel - 1                                       'make input selection to  the previous input
End If
Call Af_sel
Waitms 500
End Sub
'--------shift input right----------
Sub Shiftrt:
Set Portb.2                                                 'backlight on
W = 0                                                       'reset timer 1
Timer1 = W                                                  'write to timer 1 value
If Inp_sel < 3 Then
Inp_sel = Inp_sel + 1                                       'make input selection to  the next input
End If
Call Af_sel
Waitms 500
End Sub
'-------bring volume up-------------
Sub Volup:
Lowerline
Lcd "                "
Set Portb.2                                                 'backlight on
W = 0                                                       'reset timer 1
Timer1 = W                                                  'write to timer 1 value
Reset Portb.0                                               'alps motor run CW
Lowerline
Lcd "Volume UP !     "
Waitms 20
End Sub
'--------bring volume down----------
Sub Voldn:
Lowerline
Lcd "               "
Set Portb.2                                                 'backlight on
W = 0                                                       'reset timer 1
Timer1 = W                                                  'write to timer 1 value
Reset Portb.1                                               'alps motor run CCW
Lowerline
Lcd "Volume Down !  "
Waitms 20
End Sub
'------Af_sel---------------------------
Sub Af_sel:
Home Upper
If Inp_sel = 1 Then
Lcd "Input1  selected"
Reset Portd.5                                               'select input1
Set Portd.6                                                 'disconnect now input2
Set Portd.7                                                 'disconnect now input3
End If
If Inp_sel = 2 Then
Lcd "Input2  selected"
Set Portd.5                                                 'disconnect now input1
Reset Portd.6                                               'select input2
Set Portd.7                                                 'disconnect now input3
End If
If Inp_sel = 3 Then
Lcd "Input3  selected"
Set Portd.5                                                 'disconnect now input1
Set Portd.6                                                 'disconnect now input2
Reset Portd.7                                               'select input3
End If
End Sub
'------- Mute ----------
Sub Mute:
   Mut = Not Mut
   If Mut = 1 Then                                          'select the input as it should be
      Call Af_sel
      Lowerline
      Lcd "            "
     Waitms 500
   Else                                                     'we will mute by disconnecting input relay
      Set Portd.5                                           'disconnect now input1
      Set Portd.6                                           'disconnect now input2
      Set Portd.7                                           'disconnect now input3
      Lowerline
      Lcd "MUTE      ! "
     Waitms 500
   End If
End Sub
'----------------New RC5 code routine----------------------------------
Timer_irq:

  Timer0 = Timeconst
  Sample = Not Input_pin

   If Ir_bittimer < 255 Then
      Incr Ir_bittimer
   End If

   If Ir_lastsample <> Sample Then
      If Ir_bittimer <= Samples_min Then
         Ir_bitcount = 0
      Else
         If Ir_bittimer >= Samples_early Then
            If Ir_bittimer <= Samples_late Then
               Shift Ir_data_tmp , Left , 1
               Ir_data_tmp = Ir_data_tmp + Sample
               Incr Ir_bitcount
            Else
               Ir_bitcount = 1
               Ir_data_tmp = Sample
            End If
            Ir_bittimer = 0
         End If
      End If

     If Ir_bitcount = 1 Then
        Ir_bitcount = Ir_data_tmp.0
     End If
     If Ir_bitcount >= 14 Then
         Command_rc5 = Ir_data_tmp
         Shift Ir_data_tmp , Right , 6
         Address_rc5 = Ir_data_tmp And &B00011111
         Command_rc5.6 = Not Ir_data_tmp.6
         Command_rc5.7 = Ir_data_tmp.5
         If Address_rc5 <> 255 Then
            Set Rc5_flag
            Ir_bitcount = 0
         Else
           If Setup_add = 0 And Address_rc5 <> 255 Then
               Set Rc5_flag
               Ir_bitcount = 0
               Set_ok = 1
           Else
               Reset Rc5_flag
               Ir_bitcount = 0
           End If
         End If
     End If

  End If
  Ir_lastsample = Sample

Return